Index: sansmodels/src/sans/models/c_models/capcyl.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/capcyl.cpp	(revision 339ce675656e3ab89eff7b84d8292a2e0ffe6109)
+++ sansmodels/src/sans/models/c_models/capcyl.cpp	(revision 339ce675656e3ab89eff7b84d8292a2e0ffe6109)
@@ -0,0 +1,253 @@
+/**
+	This software was developed by the University of Tennessee as part of the
+	Distributed Data Analysis of Neutron Scattering Experiments (DANSE)
+	project funded by the US National Science Foundation.
+
+	If you use DANSE applications to do scientific research that leads to
+	publication, we ask that you acknowledge the use of the software with the
+	following sentence:
+
+	"This work benefited from DANSE software developed under NSF award DMR-0520547."
+
+	copyright 2008, University of Tennessee
+ */
+
+/**
+ * Scattering model classes
+ * The classes use the IGOR library found in
+ *   sansmodels/src/libigor
+ *
+ */
+
+#include <math.h>
+#include "models.hh"
+#include "parameters.hh"
+#include <stdio.h>
+using namespace std;
+
+extern "C" {
+	#include "libCylinder.h"
+	#include "capcyl.h"
+}
+
+CappedCylinderModel :: CappedCylinderModel() {
+	scale      = Parameter(1.0);
+	rad_cyl		= Parameter(20.0);
+	rad_cyl.set_min(0.0);
+	len_cyl     = Parameter(400.0, true);
+	len_cyl.set_min(0.0);
+	rad_cap = Parameter(40.0);
+	rad_cap.set_min(0.0);
+	sld_capcyl  = Parameter(1.0e-6);
+	sld_solv   = Parameter(6.3e-6);
+	background = Parameter(0.0);
+	theta  = Parameter(0.0, true);
+	phi    = Parameter(0.0, true);
+}
+
+/**
+ * Function to evaluate 1D scattering function
+ * The NIST IGOR library is used for the actual calculation.
+ * @param q: q-value
+ * @return: function value
+ */
+double CappedCylinderModel :: operator()(double q) {
+	double dp[7];
+
+	// Fill parameter array for IGOR library
+	// Add the background after averaging
+	dp[0] = scale();
+	dp[1] = rad_cyl();
+	dp[2] = len_cyl();
+	dp[3] = rad_cap();
+	dp[4] = sld_capcyl();
+	dp[5] = sld_solv();
+	dp[6] = 0.0;
+
+	// Get the dispersion points for the rad_cyl
+	vector<WeightPoint> weights_rad_cyl;
+	rad_cyl.get_weights(weights_rad_cyl);
+	// Get the dispersion points for the len_cyl
+	vector<WeightPoint> weights_len_cyl;
+	len_cyl.get_weights(weights_len_cyl);
+	// Get the dispersion points for the rad_cap
+	vector<WeightPoint> weights_rad_cap;
+	rad_cap.get_weights(weights_rad_cap);
+
+	// Perform the computation, with all weight points
+	double sum = 0.0;
+	double norm = 0.0;
+	double vol = 0.0;
+	double pi,hDist,result;
+	double vol_i = 0.0;
+	pi = 4.0*atan(1.0);
+	// Loop over radius weight points
+	for(int i=0; i<weights_rad_cyl.size(); i++) {
+		dp[1] = weights_rad_cyl[i].value;
+		for(int j=0; j<weights_len_cyl.size(); j++) {
+			dp[2] = weights_len_cyl[j].value;
+			for(int k=0; k<weights_rad_cap.size(); k++) {
+				dp[3] = weights_rad_cap[k].value;
+
+				//Un-normalize SphereForm by volume
+				hDist = -1.0*sqrt(fabs(dp[3]*dp[3]-dp[1]*dp[1]));
+				vol_i = pi*dp[1]*dp[1]*dp[2]+2.0*pi/3.0*((dp[3]-hDist)*(dp[3]-hDist)*
+								(2.0*(dp[3]+hDist)));
+				result =  CappedCylinder(dp, q) * vol_i;
+				// This FIXES a singualrity the kernel in libigor.
+				if ( result == INFINITY || result == NAN){
+					result = 0.0;
+				}
+				sum += weights_rad_cyl[i].weight*weights_len_cyl[j].weight*weights_rad_cap[k].weight
+					* result;
+				//Find average volume
+				vol += weights_rad_cyl[i].weight*weights_len_cyl[j].weight*weights_rad_cap[k].weight
+					* vol_i;
+
+				norm += weights_rad_cyl[i].weight*weights_len_cyl[j].weight*weights_rad_cap[k].weight;
+			}
+		}
+	}
+
+	if (vol != 0.0 && norm != 0.0) {
+		//Re-normalize by avg volume
+		sum = sum/(vol/norm);}
+	return sum/norm + background();
+}
+
+/**
+ * Function to evaluate 2D scattering function
+ * @param q_x: value of Q along x
+ * @param q_y: value of Q along y
+ * @return: function value
+ */
+double CappedCylinderModel :: operator()(double qx, double qy) {
+	CapCylParameters dp;
+
+	double q = sqrt(qx*qx + qy*qy);
+	dp.scale = scale();
+	dp.rad_cyl = rad_cyl();
+	dp.len_cyl = len_cyl();
+	dp.rad_cap = rad_cap();
+	dp.sld_capcyl = sld_capcyl();
+	dp.sld_solv = sld_solv();
+	dp.background = 0.0;
+	dp.theta  = theta();
+	dp.phi    = phi();
+
+
+	// Get the dispersion points for the rad_bar
+	vector<WeightPoint> weights_rad_cyl;
+	rad_cyl.get_weights(weights_rad_cyl);
+
+	// Get the dispersion points for the len_bar
+	vector<WeightPoint> weights_len_cyl;
+	len_cyl.get_weights(weights_len_cyl);
+
+	// Get the dispersion points for the rad_bell
+	vector<WeightPoint> weights_rad_cap;
+	rad_cap.get_weights(weights_rad_cap);
+
+	// Get angular averaging for theta
+	vector<WeightPoint> weights_theta;
+	theta.get_weights(weights_theta);
+
+	// Get angular averaging for phi
+	vector<WeightPoint> weights_phi;
+	phi.get_weights(weights_phi);
+
+
+	// Perform the computation, with all weight points
+	double sum = 0.0;
+	double norm = 0.0;
+	double norm_vol = 0.0;
+	double vol = 0.0;
+	double pi,hDist,result;
+	double vol_i = 0.0;
+	pi = 4.0*atan(1.0);
+
+	// Loop over radius weight points
+	for(int i=0; i<weights_rad_cyl.size(); i++) {
+		dp.rad_cyl = weights_rad_cyl[i].value;
+		for(int j=0; j<weights_len_cyl.size(); j++) {
+			dp.len_cyl = weights_len_cyl[j].value;
+			for(int k=0; k<weights_rad_cap.size(); k++) {
+				dp.rad_cap = weights_rad_cap[k].value;
+				// Average over theta distribution
+				for(int l=0; l< weights_theta.size(); l++) {
+					dp.theta = weights_theta[l].value;
+					// Average over phi distribution
+					for(int m=0; m< weights_phi.size(); m++) {
+						dp.phi = weights_phi[m].value;
+						//Un-normalize Form by volume
+						hDist = -1.0*sqrt(fabs(dp.rad_cap*dp.rad_cap-dp.rad_cyl*dp.rad_cyl));
+						vol_i = pi*dp.rad_cyl*dp.rad_cyl*dp.len_cyl+2.0*pi/3.0*((dp.rad_cap-hDist)*(dp.rad_cap-hDist)*
+										(2*dp.rad_cap+hDist));
+
+						double _ptvalue = weights_rad_cyl[i].weight
+											* weights_len_cyl[j].weight
+											* weights_rad_cap[k].weight
+											* weights_theta[l].weight
+											* weights_phi[m].weight
+											* vol_i
+											* capcyl_analytical_2DXY(&dp, qx, qy);
+											//* pow(weights_rad[i].value,3.0);
+						// Consider when there is infinte or nan.
+						if ( _ptvalue == INFINITY || _ptvalue == NAN){
+							_ptvalue = 0.0;
+						}
+						if (weights_theta.size()>1) {
+							_ptvalue *= sin(weights_theta[l].value);
+						}
+						sum += _ptvalue;
+						// This model dose not need the volume of spheres correction!!!
+						//Find average volume
+						vol += weights_rad_cyl[i].weight
+								* weights_len_cyl[j].weight
+								* weights_rad_cap[k].weight
+								* vol_i;
+						//Find norm for volume
+						norm_vol += weights_rad_cyl[i].weight
+								* weights_len_cyl[j].weight
+								* weights_rad_cap[k].weight;
+
+						norm += weights_rad_cyl[i].weight
+								* weights_len_cyl[j].weight
+								* weights_rad_cap[k].weight
+								* weights_theta[l].weight
+								* weights_phi[m].weight;
+					}
+				}
+			}
+		}
+	}
+	// Averaging in theta needs an extra normalization
+	// factor to account for the sin(theta) term in the
+	// integration (see documentation).
+	if (weights_theta.size()>1) norm = norm / asin(1.0);
+
+	if (vol != 0.0 && norm_vol != 0.0) {
+		//Re-normalize by avg volume
+		sum = sum/(vol/norm_vol);}
+
+	return sum/norm + background();
+}
+
+/**
+ * Function to evaluate 2D scattering function
+ * @param pars: parameters of the SCCrystal
+ * @param q: q-value
+ * @param phi: angle phi
+ * @return: function value
+ */
+double CappedCylinderModel :: evaluate_rphi(double q, double phi) {
+	return (*this).operator()(q);
+}
+
+/**
+ * Function to calculate effective radius
+ * @return: effective radius value
+ */
+double CappedCylinderModel :: calculate_ER() {
+	//NOT implemented yet!!!
+}
Index: sansmodels/src/sans/models/c_models/corefourshell.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/corefourshell.cpp	(revision c724ccd87499a21402fee0d11d517066f99ddf9b)
+++ sansmodels/src/sans/models/c_models/corefourshell.cpp	(revision 339ce675656e3ab89eff7b84d8292a2e0ffe6109)
@@ -33,7 +33,7 @@
 CoreFourShellModel :: CoreFourShellModel() {
 	scale      = Parameter(1.0);
-	rad_core     = Parameter(60.0, true);
-	rad_core.set_min(0.0);
-	sld_core   = Parameter(6.4e-6);
+	rad_core0     = Parameter(60.0, true);
+	rad_core0.set_min(0.0);
+	sld_core0   = Parameter(6.4e-6);
 	thick_shell1     = Parameter(10.0, true);
 	thick_shell1.set_min(0.0);
@@ -64,6 +64,6 @@
 	// Add the background after averaging
 	dp[0] = scale();
-	dp[1] = rad_core();
-	dp[2] = sld_core();
+	dp[1] = rad_core0();
+	dp[2] = sld_core0();
 	dp[3] = thick_shell1();
 	dp[4] = sld_shell1();
@@ -79,5 +79,5 @@
 	// Get the dispersion points for the radius
 	vector<WeightPoint> weights_rad;
-	rad_core.get_weights(weights_rad);
+	rad_core0.get_weights(weights_rad);
 
 	// Get the dispersion points for the thick 1
@@ -167,6 +167,6 @@
 
 	dp.scale = scale();
-	dp.rad_core = rad_core();
-	dp.sld_core = sld_core();
+	dp.rad_core0 = rad_core0();
+	dp.sld_core0 = sld_core0();
 	dp.thick_shell1 = thick_shell1();
 	dp.sld_shell1 = sld_shell1();
@@ -182,5 +182,5 @@
 	// Get the dispersion points for the radius
 	vector<WeightPoint> weights_rad;
-	rad_core.get_weights(weights_rad);
+	rad_core0.get_weights(weights_rad);
 
 	// Get the dispersion points for the thick 1
@@ -207,5 +207,5 @@
 	// Loop over radius weight points
 	for(int i=0; i<weights_rad.size(); i++) {
-		dp.rad_core = weights_rad[i].value;
+		dp.rad_core0 = weights_rad[i].value;
 		// Loop over radius weight points
 		for(int j=0; j<weights_s1.size(); j++) {
@@ -222,5 +222,5 @@
 						//Un-normalize FourShell by volume
 						sum += weights_rad[i].weight*weights_s1[j].weight*weights_s2[k].weight*weights_s3[l].weight*weights_s4[m].weight
-							* (dp.rad_core+dp.thick_shell1+dp.thick_shell2+dp.thick_shell3+dp.thick_shell4);
+							* (dp.rad_core0+dp.thick_shell1+dp.thick_shell2+dp.thick_shell3+dp.thick_shell4);
 						norm += weights_rad[i].weight*weights_s1[j].weight*weights_s2[k].weight*weights_s3[l].weight*weights_s4[m].weight;
 					}
@@ -234,5 +234,5 @@
 	else{
 		//return normal value
-		rad_out = dp.rad_core+dp.thick_shell1+dp.thick_shell2+dp.thick_shell3+dp.thick_shell4;}
+		rad_out = dp.rad_core0+dp.thick_shell1+dp.thick_shell2+dp.thick_shell3+dp.thick_shell4;}
 
 	return rad_out;
Index: sansmodels/src/sans/models/c_models/lamellarPC.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/lamellarPC.cpp	(revision 339ce675656e3ab89eff7b84d8292a2e0ffe6109)
+++ sansmodels/src/sans/models/c_models/lamellarPC.cpp	(revision 339ce675656e3ab89eff7b84d8292a2e0ffe6109)
@@ -0,0 +1,120 @@
+/**
+	This software was developed by the University of Tennessee as part of the
+	Distributed Data Analysis of Neutron Scattering Experiments (DANSE)
+	project funded by the US National Science Foundation.
+
+	If you use DANSE applications to do scientific research that leads to
+	publication, we ask that you acknowledge the use of the software with the
+	following sentence:
+
+	"This work benefited from DANSE software developed under NSF award DMR-0520547."
+
+	copyright 2008, University of Tennessee
+ */
+
+/**
+ * Scattering model classes
+ * The classes use the IGOR library found in
+ *   sansmodels/src/libigor
+ */
+
+#include <math.h>
+#include "models.hh"
+#include "parameters.hh"
+#include <stdio.h>
+using namespace std;
+
+extern "C" {
+	#include "libCylinder.h"
+	#include "lamellarPC.h"
+}
+
+LamellarPCrystalModel :: LamellarPCrystalModel() {
+	scale      = Parameter(1.0);
+	thickness     = Parameter(33.0, true);
+	thickness.set_min(0.0);
+	Nlayers    = Parameter(20.0, true);
+	Nlayers.set_min(0.0);
+	spacing   = Parameter(250);
+	pd_spacing   = Parameter(0.0);
+	sld_layer  = Parameter(1.0e-6);
+	sld_solvent    = Parameter(6.34e-6);
+	background = Parameter(0.0);
+
+}
+
+/**
+ * Function to evaluate 1D scattering function
+ * The NIST IGOR library is used for the actual calculation.
+ * @param q: q-value
+ * @return: function value
+ */
+double LamellarPCrystalModel :: operator()(double q) {
+	double dp[8];
+
+	// Fill parameter array for IGOR library
+	// Add the background after averaging
+	dp[0] = scale();
+	dp[1] = thickness();
+	dp[2] = Nlayers();
+	dp[3] = spacing();
+	dp[4] = pd_spacing();
+	dp[5] = sld_layer();
+	dp[6] = sld_solvent();
+	dp[7] = 0.0; // Do not apply background here.
+
+	// Get the dispersion points for the head thickness
+	vector<WeightPoint> weights_thickness;
+	thickness.get_weights(weights_thickness);
+
+	// Let's provide from the func which is more accurate especially for small q region.
+	// Get the dispersion points for the tail length
+	//vector<WeightPoint> weights_spacing;
+	//spacing.get_weights(weights_spacing);
+
+	// Perform the computation, with all weight points
+	double sum = 0.0;
+	double norm = 0.0;
+
+	// Loop over thickness and spacing weight points
+	for(int i=0; i< (int)weights_thickness.size(); i++) {
+		dp[1] = weights_thickness[i].value;
+		//for (int j=0; j< (int)weights_spacing.size(); j++){
+			//dp[3] = weights_spacing[j].value;
+			sum += weights_thickness[i].weight*Lamellar_ParaCrystal(dp, q);
+			norm += weights_thickness[i].weight;
+		//}
+	}
+	//apply norm and background
+	return sum/norm + background();
+}
+
+/**
+ * Function to evaluate 2D scattering function
+ * @param q_x: value of Q along x
+ * @param q_y: value of Q along y
+ * @return: function value
+ */
+
+double LamellarPCrystalModel :: operator()(double qx, double qy) {
+	double q = sqrt(qx*qx + qy*qy);
+	return (*this).operator()(q);
+}
+
+/**
+ * Function to evaluate 2D scattering function
+ * @param pars: parameters of the lamellar
+ * @param q: q-value
+ * @param phi: angle phi
+ * @return: function value
+ */
+double LamellarPCrystalModel :: evaluate_rphi(double q, double phi) {
+	return (*this).operator()(q);
+}
+/**
+ * Function to calculate effective radius
+ * @return: effective radius value
+ */
+double LamellarPCrystalModel :: calculate_ER() {
+//NOT implemented yet!!!
+}
Index: sansmodels/src/sans/models/c_models/models.hh
===================================================================
--- sansmodels/src/sans/models/c_models/models.hh	(revision d5b6a9d7cd9e26b5f9e28e55e8cf848a40de6ae9)
+++ sansmodels/src/sans/models/c_models/models.hh	(revision 339ce675656e3ab89eff7b84d8292a2e0ffe6109)
@@ -49,4 +49,51 @@
 };
 
+class BarBellModel{
+public:
+	// Model parameters
+	Parameter scale;
+	Parameter rad_bar;
+	Parameter len_bar;
+	Parameter rad_bell;
+	Parameter sld_barbell;
+	Parameter sld_solv;
+	Parameter background;
+	Parameter theta;
+	Parameter phi;
+
+	// Constructor
+	BarBellModel();
+
+	// Operators to get I(Q)
+	double operator()(double q);
+	double operator()(double qx, double qy);
+	double calculate_ER();
+	double evaluate_rphi(double q, double phi);
+};
+
+class CappedCylinderModel{
+public:
+	// Model parameters
+	Parameter scale;
+	Parameter rad_cyl;
+	Parameter len_cyl;
+	Parameter rad_cap;
+	Parameter sld_capcyl;
+	Parameter sld_solv;
+	Parameter background;
+	Parameter theta;
+	Parameter phi;
+
+	// Constructor
+	CappedCylinderModel();
+
+	// Operators to get I(Q)
+	double operator()(double q);
+	double operator()(double qx, double qy);
+	double calculate_ER();
+	double evaluate_rphi(double q, double phi);
+};
+
+
 class ParallelepipedModel{
 public:
@@ -80,6 +127,6 @@
 	Parameter n_shells;
 	Parameter scale;
-	Parameter rad_core;
-	Parameter sld_core;
+	Parameter rad_core0;
+	Parameter sld_core0;
 	Parameter sld_solv;
 	Parameter background;
@@ -256,4 +303,18 @@
 	Parameter func_inter10;
 
+	Parameter sldIM_flat1;
+	Parameter sldIM_flat2;
+	Parameter sldIM_flat3;
+	Parameter sldIM_flat4;
+	Parameter sldIM_flat5;
+	Parameter sldIM_flat6;
+	Parameter sldIM_flat7;
+	Parameter sldIM_flat8;
+	Parameter sldIM_flat9;
+	Parameter sldIM_flat10;
+
+	Parameter sldIM_sub0;
+	Parameter sldIM_medium;
+
 	// Constructor
 	ReflModel();
@@ -511,6 +572,6 @@
 	// Model parameters
 	Parameter scale;
-	Parameter rad_core;
-	Parameter sld_core;
+	Parameter rad_core0;
+	Parameter sld_core0;
 	Parameter thick_shell1;
 	Parameter sld_shell1;
Index: sansmodels/src/sans/models/c_models/onion.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/onion.cpp	(revision e096270047b0757e07e7187aa5de071c857a7e13)
+++ sansmodels/src/sans/models/c_models/onion.cpp	(revision 339ce675656e3ab89eff7b84d8292a2e0ffe6109)
@@ -33,6 +33,6 @@
 	n_shells = Parameter(1.0);
 	scale = Parameter(1.0);
-	rad_core = Parameter(200.0);
-	sld_core = Parameter(1e-06);
+	rad_core0 = Parameter(200.0);
+	sld_core0 = Parameter(1e-06);
 	sld_solv = Parameter(6.4e-06);
     background = Parameter(0.0);
@@ -112,6 +112,6 @@
 	dp[0] = n_shells();
 	dp[1] = scale();
-	dp[2] = rad_core();
-	dp[3] = sld_core();
+	dp[2] = rad_core0();
+	dp[3] = sld_core0();
 	dp[4] = sld_solv();
 	dp[5] = 0.0;
@@ -175,5 +175,5 @@
 	// Get the dispersion points for the radius
 	vector<WeightPoint> weights_rad;
-	rad_core.get_weights(weights_rad);
+	rad_core0.get_weights(weights_rad);
 
 	// Get the dispersion points for the thick 1
@@ -313,5 +313,5 @@
 double OnionModel :: calculate_ER() {
 	OnionParameters dp;
-	dp.rad_core = rad_core();
+	dp.rad_core0 = rad_core0();
 	dp.thick_shell1 = thick_shell1();
 	dp.thick_shell2 = thick_shell2();
@@ -333,5 +333,5 @@
 	// Get the dispersion points for the radius
 	vector<WeightPoint> weights_rad;
-	rad_core.get_weights(weights_rad);
+	rad_core0.get_weights(weights_rad);
 
 	// Get the dispersion points for the thick 1
@@ -376,5 +376,5 @@
 	// Loop over radius weight points
 	for(int i=0; i<weights_rad.size(); i++) {
-		dp.rad_core = weights_rad[i].value;
+		dp.rad_core0 = weights_rad[i].value;
 		// Loop over radius weight points
 		for(int j=0; j<weights_s1.size(); j++) {
@@ -411,5 +411,5 @@
 													*weights_s5[n].weight*weights_s6[o].weight*weights_s7[p].weight*weights_s8[t].weight
 													*weights_s9[r].weight*weights_s10[s].weight
-													* (dp.rad_core+dp.thick_shell1+dp.thick_shell2+dp.thick_shell3+dp.thick_shell4+dp.thick_shell5
+													* (dp.rad_core0+dp.thick_shell1+dp.thick_shell2+dp.thick_shell3+dp.thick_shell4+dp.thick_shell5
 															+dp.thick_shell6+dp.thick_shell7+dp.thick_shell8+dp.thick_shell9+dp.thick_shell10);
 												norm += weights_rad[i].weight*weights_s1[j].weight*weights_s2[k].weight*weights_s3[l].weight
@@ -433,5 +433,5 @@
 	else{
 		//return normal value
-		rad_out = dp.rad_core+dp.thick_shell1+dp.thick_shell2+dp.thick_shell3+dp.thick_shell4
+		rad_out = dp.rad_core0+dp.thick_shell1+dp.thick_shell2+dp.thick_shell3+dp.thick_shell4
 					+dp.thick_shell5+dp.thick_shell6+dp.thick_shell7+dp.thick_shell8+dp.thick_shell9+dp.thick_shell10;}
 	return rad_out;
Index: sansmodels/src/sans/models/c_models/refl.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/refl.cpp	(revision 35aface36aa7573475600ebbacb987f50386d5f8)
+++ sansmodels/src/sans/models/c_models/refl.cpp	(revision 339ce675656e3ab89eff7b84d8292a2e0ffe6109)
@@ -67,4 +67,17 @@
     func_inter10 = Parameter(0);
 
+    sldIM_flat1 = Parameter(0);
+    sldIM_flat2 = Parameter(0);
+    sldIM_flat3 = Parameter(0);
+    sldIM_flat4 = Parameter(0);
+    sldIM_flat5 = Parameter(0);
+    sldIM_flat6 = Parameter(0);
+    sldIM_flat7 = Parameter(0);
+    sldIM_flat8 = Parameter(0);
+    sldIM_flat9 = Parameter(0);
+    sldIM_flat10 = Parameter(0);
+
+    sldIM_sub0 = Parameter(0);
+    sldIM_medium = Parameter(0);
 }
 
@@ -75,5 +88,5 @@
  */
 double ReflModel :: operator()(double q) {
-	double dp[47];
+	double dp[59];
 	// Fill parameter array for IGOR library
 	// Add the background after averaging
@@ -130,4 +143,18 @@
 	dp[46] = func_inter10();
 
+	dp[47] = sldIM_flat1();
+	dp[48] = sldIM_flat2();
+	dp[49] = sldIM_flat3();
+	dp[50] = sldIM_flat4();
+	dp[51] = sldIM_flat5();
+	dp[52] = sldIM_flat6();
+	dp[53] = sldIM_flat7();
+	dp[54] = sldIM_flat8();
+	dp[55] = sldIM_flat9();
+	dp[56] = sldIM_flat10();
+
+	dp[57] = sldIM_sub0();
+	dp[58] = sldIM_medium();
+
 	// Get the dispersion points for the radius
 	//vector<WeightPoint> weights_thick;
Index: sansmodels/src/sans/models/test/utest_extra_models.py
===================================================================
--- sansmodels/src/sans/models/test/utest_extra_models.py	(revision 35aface36aa7573475600ebbacb987f50386d5f8)
+++ sansmodels/src/sans/models/test/utest_extra_models.py	(revision 339ce675656e3ab89eff7b84d8292a2e0ffe6109)
@@ -1,9 +1,11 @@
 """
-    Unit tests for extra models,PolymerexclVolume, RPA10Model
+Unit tests for extra models,PolymerexclVolume, RPA10Model
+The reference values are calculated on IGOR/NIST package(Oct.,2010)
+@author: JHJ Cho / UTK
 """
 import unittest
 class TestPolymerExclVolume(unittest.TestCase):
     """
-        Unit tests for PolymerexclVolume (non-shape) function
+    Unit tests for PolymerexclVolume (non-shape) function
     """
     def setUp(self):
@@ -17,7 +19,7 @@
         self.assertAlmostEqual(self.model.runXY(0.41959), 0.000261302, 6)
         
-class TestPolymerExclVolume(unittest.TestCase):
+class TestRPA10Case(unittest.TestCase):
     """
-        Unit tests for RPA10Model (non-shape) function
+    Unit tests for RPA10Model (non-shape) function
     """
     def setUp(self):
@@ -83,6 +85,98 @@
         # case 9
         self.assertAlmostEqual(self.model9.run(0.001), 0.00839376, 6)
-        self.assertAlmostEqual(self.model9.runXY(0.414955), 0.00305777, 6)        
+        self.assertAlmostEqual(self.model9.runXY(0.414955), 0.00305777, 6)  
+              
+class TestBarBell(unittest.TestCase):
+    """
+    Unit tests for BarBell function
+    """
+    def setUp(self):
+        from sans.models.BarBellModel import BarBellModel
+        self.model= BarBellModel()
         
+    def test1D(self):          
+        # the values are from Igor pro calculation    
+        self.assertAlmostEqual(self.model.run(0.001), 2864.7, 1)
+        self.assertAlmostEqual(self.model.run(0.215268), 0.526351, 4)
+        self.assertAlmostEqual(self.model.runXY(0.414467), 0.0685892, 6)
+
+class TestCappedCylinder(unittest.TestCase):
+    """
+    Unit tests for CappedCylinder function
+    """
+    def setUp(self):
+        from sans.models.CappedCylinderModel import CappedCylinderModel
+        self.model= CappedCylinderModel()
+        
+    def test1D(self):          
+        # the values are from Igor pro calculation  
+        # the different digits are due to precision of q values  
+        self.assertAlmostEqual(self.model.run(0.001), 1424.72, 2)
+        self.assertAlmostEqual(self.model.run(0.215268), 0.360736, 4)
+        self.assertAlmostEqual(self.model.runXY(0.414467), 0.110283, 5)
+
+class TestLamellarParaCrystal(unittest.TestCase):
+    """
+    Unit tests for LamellarParaCystal function
+    """
+    def setUp(self):
+        from sans.models.LamellarPCrystalModel import LamellarPCrystalModel
+        self.model= LamellarPCrystalModel()
+        
+    def test1D(self):    
+        self.model.setParam("pd_spacing", 0.2)      
+        # the values are from Igor pro calculation  
+        # the different digits are due to precision of q values  
+        self.assertAlmostEqual(self.model.run(0.001), 21829.3, 1)
+        self.assertAlmostEqual(self.model.run(0.215268), 0.00487686, 6)
+        self.assertAlmostEqual(self.model.runXY(0.414467), 0.00062029, 6)
+
+
+class TestSCParaCrystal(unittest.TestCase):
+    """
+    Unit tests for Simple Cubic ParaCrystal Model function
+    """
+    def setUp(self):
+        from sans.models.SCCrystalModel import SCCrystalModel
+        self.model= SCCrystalModel()
+        
+    def test1D(self):        
+        # the values are from Igor pro calculation  
+        # the different digits are due to precision of q values  
+        self.assertAlmostEqual(self.model.run(0.001), 10.3038, 4)
+        self.assertAlmostEqual(self.model.run(0.215268), 0.00714905, 6)
+        self.assertAlmostEqual(self.model.runXY(0.414467), 0.000313289, 6)
+
+class TestFCParaCrystal(unittest.TestCase):
+    """
+    Unit tests for Face Centered Cubic ParaCrystal Model function
+    """
+    def setUp(self):
+        from sans.models.FCCrystalModel import FCCrystalModel
+        self.model= FCCrystalModel()
+        
+    def test1D(self):       
+        self.model.setParam("d_factor", 0.05)  
+        # the values are from Igor pro calculation  
+        # the different digits are due to precision of q values  
+        self.assertAlmostEqual(self.model.run(0.001), 0.121017, 6)
+        self.assertAlmostEqual(self.model.run(0.215268), 0.0107218, 6)
+        self.assertAlmostEqual(self.model.runXY(0.414467), 0.000443282, 6)
+
+class TestBCParaCrystal(unittest.TestCase):
+    """
+    Unit tests for Body Centered Cubic ParaCrystal Model function
+    """
+    def setUp(self):
+        from sans.models.BCCrystalModel import BCCrystalModel
+        self.model= BCCrystalModel()
+        
+    def test1D(self):        
+        # the values are from Igor pro calculation  
+        # the different digits are due to precision of q values  
+        self.assertAlmostEqual(self.model.run(0.001), 1.77267, 4)
+        self.assertAlmostEqual(self.model.run(0.215268), 0.00927739, 6)
+        self.assertAlmostEqual(self.model.runXY(0.414467), 0.000406973, 6)
+                                                        
 if __name__ == '__main__':
     unittest.main()
Index: sansmodels/src/sans/models/test/utest_model_sphereexpshell.py
===================================================================
--- sansmodels/src/sans/models/test/utest_model_sphereexpshell.py	(revision 1e7de3879a0b2ff6e6fa055a97d34d6d554b2a95)
+++ sansmodels/src/sans/models/test/utest_model_sphereexpshell.py	(revision 339ce675656e3ab89eff7b84d8292a2e0ffe6109)
@@ -42,7 +42,7 @@
         # model3: set param values as same as the model2
         self.model3.setParam("background", 0.0)
-        self.model3.setParam("rad_core", 200.0)
+        self.model3.setParam("rad_core0", 200.0)
         self.model3.setParam("scale", 1.0)
-        self.model3.setParam("sld_core", 1.0e-006)
+        self.model3.setParam("sld_core0", 1.0e-006)
         self.model3.setParam("sld_shell1", 1.7e-006)
         self.model3.setParam("sld_solv", 6.4e-006)
@@ -72,7 +72,7 @@
         # model: set param values as same as the model2
         self.model.setParam("background", 0.0)
-        self.model.setParam("rad_core", 100.0)
+        self.model.setParam("rad_core0", 100.0)
         self.model.setParam("scale", 1.0)
-        self.model.setParam("sld_core", 6.36e-006)
+        self.model.setParam("sld_core0", 6.36e-006)
         self.model.setParam("sld_in_shell1", 5e-007)
         self.model.setParam("sld_solv", 6.36e-006)
@@ -80,7 +80,7 @@
         # model2: set param values as same as the model2
         self.model2.setParam("background", 0.0)
-        self.model2.setParam("rad_core", 100.0)
+        self.model2.setParam("rad_core0", 100.0)
         self.model2.setParam("scale", 1.0)
-        self.model2.setParam("sld_core", 6.36e-006)
+        self.model2.setParam("sld_core0", 6.36e-006)
         self.model2.setParam("sld_in_shell1", 5e-007)
         self.model2.setParam("sld_solv", 6.36e-006)
